import greenfoot.*;  // （World、Actor、GreenfootImage、GreenfootSound、Greenfoot及MouseInfo）
import java.util.List;

/**
 * 數周圍地雷的數目。
 * 
 * @author 依瑪貓
 * @version 2013-04-12
 */
public class Count extends Actor {
    
    /** 數字。 */
    private int count = -1;
    
    /**
     * 加進場景後執行的動作。
     * 
     * @param world 場景。
     */
    public void addedToWorld(World world) {
        List<Bomb> bombs = getNeighbours(1, true, Bomb.class);
        count = bombs.size();
        if (count == 0) {
            world.removeObject(this);
        } else {
            setImage("count" + count + ".png");
        }
    }
    
    /**
     * 取得周圍地雷的數目。
     * 
     * @return 周圍地雷的數目
     */
    public int getCount() {
        return count;
    }
}