import greenfoot.*;  // （World、Actor、GreenfootImage、GreenfootSound、Greenfoot及MouseInfo）
import java.util.List;

/**
 * 地雷的蓋板。
 * 
 * @author 依瑪貓
 * @version 2013-04-12
 */
public class Cover extends Actor {
    
    /**
     * 每個回合執行的動作。
     * 
     */
    public void act() {
        if (Greenfoot.mouseClicked(this)) {
            MouseInfo mouse = Greenfoot.getMouseInfo();
            if (mouse.getButton() == 1) {
                open();
            } else if (mouse.getButton() == 3) {
                getWorld().addObject(new Flag(), getX(), getY());
            }
        }
    }
    
    /**
     * 打開這一格。
     * 
     */
    public void open() {
        // 已經翻開了，就直接結束。
        // 因為是遞迴呼叫，有時候會被下一層先作為周圍的格子先翻開。
        if (getWorld() == null) {
            return;
        }
        
        // 有標記的話，就不翻開。
        Flag flag = (Flag) getOneIntersectingObject(Flag.class);
        Question question = (Question) getOneIntersectingObject(Question.class);
        if (flag != null || question != null) {
            return;
        }
        
        // 有炸彈，就爆炸。
        Bomb bomb  = (Bomb) getOneIntersectingObject(Bomb.class);
        if (bomb != null) {
            getWorld().removeObject(this);
            bomb.boom();
            return;
        }
        
        // 如果有地雷數，只翻開這一格。
        Count count = (Count) getOneIntersectingObject(Count.class);
        if (count != null) {
            getWorld().removeObject(this);
            return;
        }
        
        // 沒有地雷數，則翻開周圍還沒翻開的格子。
        List<Cover> covers = getNeighbours(1, true, Cover.class);
        getWorld().removeObject(this);
        for (Cover cover : covers) {
            cover.open();
        }
    }
}